//modified by Jing Yang after 7/6/2001
#include <xmdv/InterRing/CInterRingDimClusterTree.h>
#include <stdio.h>
#include <xmdv/XmdvTool.h>
#include <string.h>

CInterRingDimClusterTree::CInterRingDimClusterTree() : CInterRingClusterTree()
{
//start_jing_reorder
    order_type = NO_ORDER;
//end_jing_reorder
}


CInterRingDimClusterTree::~CInterRingDimClusterTree()
{

}

//build the dim cluster tree according to a file;
//fname: name of the file;
bool CInterRingDimClusterTree::BuildInterRingDimClusterTreeFromFile(const char* fname)
{
    int i;
    assert(dataset);

	//read the nodes into arrays from the file;
    FILE *fptr = fopen(fname,"r");
    if (fptr==NULL) 
        return false;

//    dim_cluster_file = strdup(fname);

    // Get file size
    int num_nodes;
    if (fscanf(fptr, "%d\n", &num_nodes)<=0)
    {
        printf("Error reading the first line of the file %s\n", fname);
        printf("Format of the first line: #nodes\n");
        return false;
    }
    // Allocate space for all node pointers and parent_ids;
    //
    ARR<CInterRingCluster *> nodes;
	ARR<int> parent_ids;

	nodes.SetLen(num_nodes);
    parent_ids.SetLen(num_nodes);

	for ( i = 0; i < num_nodes; i++ )
	{
		nodes[i] = NULL;
		parent_ids[i] = -2;
	}

    printf("Number of dimension cluster nodes=%d\n", num_nodes);


    for(i=0; i<num_nodes; i++) 
	{
		nodes[i] = NULL;
    }

    int id, okc_id;
	char temp_name[50];
	for(i = 0; i < num_nodes; i++)
	{
		if ( fscanf(fptr, "%d", &id) != 1 ) 
            return false;
		nodes[id] = new CInterRingDimCluster();
		fscanf(fptr, "%d %d %lf %d", &parent_ids[id], &(nodes[id]->entries), &(nodes[id]->radius), &okc_id);
        ((CInterRingDimCluster *)nodes[id])->okc_id = okc_id;
        if ( okc_id >= 0 )
            strcpy(temp_name, dataset->names[okc_id]);
        else
            sprintf(temp_name, "Node%1d", id);

		((CInterRingDimCluster *)nodes[id])->name = new char[strlen(temp_name)+1];
		strcpy(((CInterRingDimCluster *)nodes[id])->name, temp_name);
	}
    
	fclose(fptr);

	//construct the dim cluster tree according to the arrays;
	if ( ConstructInterRingClusterTree(num_nodes, nodes, parent_ids) )
    {
        //ResetNames();
        return true;
    }
    else
    {
        return false;
    }
}


void CInterRingDimClusterTree::ResetNames()
{
	((CInterRingDimCluster *)root)->ResetNames();
}


void CInterRingDimClusterTree::ResetSelection()
{
    if ( dim_reducer != NULL )
    {
        dim_reducer->SetStatus("normal");        
        dim_reducer->ResetRepresentativeDimList();
    }
}


void CInterRingDimClusterTree::PCA()
{
	((CInterRingDimCluster *)root)->PCA();
}

